VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Counting Timer "
   ClientHeight    =   3285
   ClientLeft      =   3165
   ClientTop       =   1905
   ClientWidth     =   4440
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3285
   ScaleWidth      =   4440
   Begin VB.TextBox txtDuration 
      Height          =   285
      Left            =   2940
      TabIndex        =   2
      Text            =   "1000"
      Top             =   315
      Width           =   1065
   End
   Begin VB.Frame fraPeriods 
      Caption         =   "Resolution: "
      Height          =   1620
      Left            =   105
      TabIndex        =   7
      Top             =   105
      Width           =   2640
      Begin VB.CommandButton cmdSetPeriod 
         Caption         =   "&Set"
         Enabled         =   0   'False
         Height          =   255
         Left            =   2010
         TabIndex        =   1
         Top             =   1185
         Width           =   435
      End
      Begin VB.TextBox txtCurrentPeriod 
         Height          =   285
         Left            =   1095
         TabIndex        =   0
         Top             =   1170
         Width           =   810
      End
      Begin VB.Label lblMaximumPeriod 
         BorderStyle     =   1  'Fixed Single
         Height          =   285
         Left            =   1095
         TabIndex        =   11
         Top             =   795
         Width           =   810
      End
      Begin VB.Label lblMinimumPeriod 
         BorderStyle     =   1  'Fixed Single
         Height          =   285
         Left            =   1095
         TabIndex        =   10
         Top             =   420
         Width           =   810
      End
      Begin VB.Label Labels 
         Caption         =   "Desired:"
         Height          =   195
         Index           =   2
         Left            =   255
         TabIndex        =   6
         Top             =   1185
         Width           =   705
      End
      Begin VB.Label Labels 
         Caption         =   "Maximum:"
         Height          =   195
         Index           =   1
         Left            =   255
         TabIndex        =   9
         Top             =   810
         Width           =   705
      End
      Begin VB.Label Labels 
         Caption         =   "Minimum:"
         Height          =   195
         Index           =   0
         Left            =   255
         TabIndex        =   8
         Top             =   435
         Width           =   705
      End
   End
   Begin VB.ListBox lstInfo 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1320
      Left            =   75
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   1890
      Width           =   4260
   End
   Begin VB.CommandButton cmdRun 
      Caption         =   "Start Timer"
      Default         =   -1  'True
      Height          =   330
      Left            =   2940
      TabIndex        =   3
      Top             =   1365
      Width           =   1380
   End
   Begin VB.Label Labels 
      Caption         =   "Timer Duration:"
      Height          =   195
      Index           =   3
      Left            =   2940
      TabIndex        =   5
      Top             =   105
      Width           =   1230
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private glCurrentPeriod As Long
Private oStopWatch      As StopWatch.clsStopWatch

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Sub cmdRun_Click()
Dim sTemp     As String
Dim lDuration As Long
Dim lElapsed  As Long
'
' Validate the duration.
'
sTemp = Trim(txtDuration)
If Len(sTemp) = 0 Then
    MsgBox "Enter a Sleep() Duration.", vbOKOnly + vbExclamation, "Data Entry Error"
    txtDuration.SetFocus
    Exit Sub
End If

If Not IsNumeric(sTemp) Then
    MsgBox "Sleep() Duration must be numeric.", vbOKOnly + vbExclamation, "Data Entry Error"
    txtDuration.SetFocus
    Exit Sub
End If

lDuration = CLng(sTemp)
If lDuration <= 0 Then
    MsgBox "Sleep() Duration must be positive.", vbOKOnly + vbExclamation, "Data Entry Error"
    txtDuration.SetFocus
    Exit Sub
End If
'
' Disable the form's controls.
'
Call pEnableForm(False)
'
' Reset the timer.
'
oStopWatch.Reset
'
' Sleep for the specified duration.
'
Call Sleep(lDuration)
'
' Get the time the sleep operation took.
'
lElapsed = oStopWatch.ElapsedTime
'
' Display a message.
'
Call pAddMessage("Sleep(" & lDuration & ") took " & Format(lElapsed, "#,##0") & " milliseconds")
'
' Enable the form's controls.
'
Call pEnableForm(True)
End Sub

Private Sub cmdSetPeriod_Click()
Dim lTemp    As String
Dim lPeriod  As Long
'
' Validate the Period.
'
lTemp = Trim(txtCurrentPeriod)
If Len(lTemp) = 0 Then
    MsgBox "Must enter a Period.", vbOKOnly + vbExclamation, "Data Entry Error"
    txtCurrentPeriod.SetFocus
    Exit Sub
End If

If Not IsNumeric(lTemp) Then
    MsgBox "Period must be numeric.", vbOKOnly + vbExclamation, "Data Entry Error"
    txtCurrentPeriod.SetFocus
    Exit Sub
End If

lPeriod = CLng(lTemp)
If lPeriod <= 0 Then
    MsgBox "Period must be positive.", vbOKOnly + vbExclamation, "Data Entry Error"
    txtCurrentPeriod.SetFocus
    Exit Sub
End If

If lPeriod = glCurrentPeriod Then
    Beep
    Exit Sub
End If
'
' Disable the form's controls.
'
Call pEnableForm(False)
On Error GoTo ErrorHandler

If glCurrentPeriod > 0 Then
    Call oStopWatch.EndPeriod(glCurrentPeriod)
End If

glCurrentPeriod = lPeriod
Call oStopWatch.BeginPeriod(glCurrentPeriod)
'
' Enable the form's controls.
'
Call pEnableForm(True)
Exit Sub

ErrorHandler:
    With Err
        MsgBox "Error in " & .Source & " - " & .Description
    End With
    
    glCurrentPeriod = 0
    Call pEnableForm(True)
End Sub

Private Sub Form_Initialize()
'
' Instantiate the timer.
'
Set oStopWatch = New StopWatch.clsStopWatch
glCurrentPeriod = 0
End Sub

Private Sub Form_Load()
Const MAX_PRECISION = 1
'
' Get the minimum and maximum periods from the timer.
'
lblMinimumPeriod = oStopWatch.MinPeriod
lblMaximumPeriod = oStopWatch.MaxPeriod
'
' Set the period for maximum precision.
'
txtCurrentPeriod = MAX_PRECISION
cmdSetPeriod_Click

frmMain.Show

Call pEnableForm(True)
End Sub

Private Sub Form_Terminate()
'
' Ignore errors when quitting.
'
On Error Resume Next

If glCurrentPeriod > 0 Then
    oStopWatch.EndPeriod glCurrentPeriod
End If

Set oStopWatch = Nothing
End Sub

Private Sub Form_Unload(Cancel As Integer)
Set frmMain = Nothing
End Sub

Private Sub lstInfo_DblClick()
lstInfo.Clear
End Sub

Private Sub txtCurrentPeriod_Change()
Call pEnableForm(True)
End Sub

Private Sub txtDuration_Change()
Call pEnableForm(True)
End Sub

Public Sub pAddMessage(Optional sMsg As String = "")

With lstInfo
    .AddItem sMsg
    .ListIndex = .NewIndex
    .Selected(.ListIndex) = False
    .Refresh
End With
End Sub

Private Sub pEnableForm(Optional ByVal bState As Boolean = False)

fraPeriods.Enabled = bState
cmdRun.Enabled = (bState And Len(txtDuration) > 0)
cmdSetPeriod.Enabled = (bState And Len(txtCurrentPeriod) > 0)

frmMain.MousePointer = IIf(bState, vbDefault, vbHourglass)
frmMain.Refresh
End Sub
